// bitmap.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Vds.h"

struct bmRGB
{
	BYTE B;
	BYTE G;
	BYTE R;
};

void bmMatrixRotate(bmRGB *matrix,int width, int height)
{
	int i,j,k=0;
	bmRGB *tgBmRGB_Matrixx;
	tgBmRGB_Matrixx = new bmRGB[width*height];
	
	for(j=0; j<width; j++)
    {
	   for(i=height-1; i>=0; i--)
	   {
		   tgBmRGB_Matrixx[k].B = matrix[i*width + j].B;
		   tgBmRGB_Matrixx[k].G = matrix[i*width + j].G;
		   tgBmRGB_Matrixx[k].R = matrix[i*width + j].R;
		   k++;
	   }
    }
	k=0;
	for(i=0; i<width; i++)
    {
	   for(j=0; j<height; j++)
	   {
		   matrix[i*height + j].B = tgBmRGB_Matrixx[k].B;
		   matrix[i*height + j].G = tgBmRGB_Matrixx[k].G;
		   matrix[i*height + j].R = tgBmRGB_Matrixx[k].R;
		   k++;
	   }
    }

	delete []tgBmRGB_Matrixx;
}
void bmMatrixTransform(bmRGB *matrix,int width, int height, int mode)
{
	int i,temp;
	for(i=0; i<=mode; i++)
	{
		bmMatrixRotate(matrix,width,height);
		temp = width;
		width = height;
		height = temp;
	}	
}
void save_bmp(tagBITMAPFILEHEADER tgHeader,tagBITMAPINFOHEADER tgIHeader, bmRGB *tgBmRGB_Matrix,char *fname)
{
	bmRGB tgBmRGB;
	FILE *bmp = fopen(fname,"w");
		 if (bmp != NULL)
		 {
			 int NUM=0;
			 int i,j;
			 bool writeByte;
			 BYTE elem=0;
			 fwrite(&tgHeader,sizeof(tagBITMAPFILEHEADER),1,bmp);
			 fwrite(&tgIHeader,sizeof(tagBITMAPINFOHEADER),1,bmp);
			 NUM=0; writeByte = false;
			 while((((tgIHeader.biWidth*tgIHeader.biBitCount)/8)+NUM)%4 != 0)
			 {
				 writeByte = true;
				 NUM++;
			 }

			 for(j=0; j<tgIHeader.biHeight; j++)
		     {
				 for(i=0; i<tgIHeader.biWidth; i++)
				 {
					 
					 tgBmRGB.B = tgBmRGB_Matrix[j*tgIHeader.biWidth + i].B;
					 tgBmRGB.G = tgBmRGB_Matrix[j*tgIHeader.biWidth + i].G;
					 tgBmRGB.R = tgBmRGB_Matrix[j*tgIHeader.biWidth + i].R;
					 fwrite(&tgBmRGB,sizeof(tgBmRGB),1,bmp);
				 }
				 if(writeByte){fwrite(&elem,sizeof(elem),NUM,bmp);}
		     }
		 }
		 fclose(bmp);
		 printf("FILE %s SAVED\n",fname);

}
void main()
{
	int i,j;
	int temp;
	BYTE elem=0;
	bool writeByte=false;
	int NUM = 0;
	FILE *bmp = fopen("input.bmp","r");
	if (bmp != NULL)
	{
		tagBITMAPFILEHEADER tgHeader;
		tagBITMAPINFOHEADER tgIHeader;
		bmRGB tgBmRGB;
		bmRGB *tgBmRGB_Matrix,*tgBmRGB_Matrix2;
		fread(&tgHeader,sizeof(tagBITMAPFILEHEADER),1,bmp);
		fread(&tgIHeader,sizeof(tagBITMAPINFOHEADER),1,bmp);
		
		printf("Loaded input.bmp \n");
		printf("--------------------\n");
		printf("Type    %A \n",tgHeader.bfType);
		printf("Size    %d bytes\n",tgHeader.bfSize);
	    printf("OBts    %d bytes\n\n",tgHeader.bfOffBits);

		printf("Width   %d \n",tgIHeader.biWidth);
		printf("Height  %d \n",tgIHeader.biHeight);
		printf("BitCnt  %d \n",tgIHeader.biBitCount);
		printf("Cmprsn  %d ",tgIHeader.biCompression);
		 switch(tgIHeader.biCompression)
		 {
		 case 0: printf("(BI_RGB)"); break;
		 case 1: printf("(BI_RLE8)"); break;
		 case 2: printf("(BI_RLE4)"); break;
		 case 3: printf("(BI_BITFIELDS)"); break;
		 case 4: printf("(BI_JPEG)"); break;
         case 5: printf("(BI_PNG)"); break;
		 }printf("\n\n");

		 tgBmRGB_Matrix = new bmRGB[tgIHeader.biWidth*tgIHeader.biHeight];
		 while((((tgIHeader.biWidth*tgIHeader.biBitCount)/8)+NUM)%4 != 0)
		 {
			 writeByte = true;
			 NUM++;
		 }
		 for(j=0; j<tgIHeader.biHeight; j++)
		 {
			 for(i=0; i<tgIHeader.biWidth; i++)
			 {
				 fread(&tgBmRGB,sizeof(tgBmRGB),1,bmp);
				 tgBmRGB_Matrix[j*tgIHeader.biWidth + i].B = tgBmRGB.B;
				 tgBmRGB_Matrix[j*tgIHeader.biWidth + i].G = tgBmRGB.G;
				 tgBmRGB_Matrix[j*tgIHeader.biWidth + i].R = tgBmRGB.R;
			 }
			 if(writeByte){fread(&elem,sizeof(elem),NUM,bmp);}
		 }
		 printf("FILE MATRIX SAVED\n");
		 fclose(bmp);
		 printf("--------------------\n");
		 printf("Closed input.bmp\n");

		 bmMatrixTransform(tgBmRGB_Matrix,tgIHeader.biWidth,tgIHeader.biHeight,0);
		 temp = tgIHeader.biWidth;
		 tgIHeader.biWidth = tgIHeader.biHeight;
		 tgIHeader.biHeight = temp;
		 save_bmp(tgHeader,tgIHeader,tgBmRGB_Matrix,"output90.bmp");
		 bmMatrixTransform(tgBmRGB_Matrix,tgIHeader.biWidth,tgIHeader.biHeight,0);
		 temp = tgIHeader.biWidth;
		 tgIHeader.biWidth = tgIHeader.biHeight;
		 tgIHeader.biHeight = temp;
		 save_bmp(tgHeader,tgIHeader,tgBmRGB_Matrix,"output180.bmp");
		 bmMatrixTransform(tgBmRGB_Matrix,tgIHeader.biWidth,tgIHeader.biHeight,0);
		 temp = tgIHeader.biWidth;
		 tgIHeader.biWidth = tgIHeader.biHeight;
		 tgIHeader.biHeight = temp;
		 save_bmp(tgHeader,tgIHeader,tgBmRGB_Matrix,"output270.bmp");
		 bmMatrixTransform(tgBmRGB_Matrix,tgIHeader.biWidth,tgIHeader.biHeight,0);
		 temp = tgIHeader.biWidth;
		 tgIHeader.biWidth = tgIHeader.biHeight;
		 tgIHeader.biHeight = temp;
		 save_bmp(tgHeader,tgIHeader,tgBmRGB_Matrix,"output360.bmp");    

		 scanf("%d",&i);
	}
}

